#include <iostream>
#include <cmath>

#define f(i,n) for(int i = 0 ; i < (n) ; i ++)
#define x first
#define y second
#define mp std::make_pair
#define eps 1e-6

typedef std::pair<int,int> point;
typedef std::pair<double,double> pointD;

pointD operator+(const pointD &a, const pointD &b)
{
	pointD res;
	res.x = a.x + b.x;	res.y = a.y + b.y;
	return res;
}

double cp(pointD a, pointD b, point c)
{
	return (b.x - a.x) * (c.y - a.y) - (c.x - a.x) * (b.y - a.y);
}

int n1,n2, X1, Y1, X2, Y2;
point w[105], b[105];
pointD W,B,v;


void Print()
{
	double mx = std::max( fabs(v.x), fabs(v.y) ) + 1.;
	if( mx < 1.95 )
		;
	else
	{
		v.x /= mx; v.y /= mx;
	}
	printf("%lf %lf %lf %lf\n", W.x, W.y, v.x,v.y);
	exit(0);
}

int main()
{
	scanf("%d", &n1);
	f(i, n1)
	{
		scanf("%d %d", &w[i].x, &w[i].y);
		X1 += w[i].x; Y1 += w[i].y;
	}
	W.x = X1 / (double)n1; W.y = Y1 / (double)n1;
	scanf("%d", &n2);
	f(i, n2)
	{
		scanf("%d %d", &b[i].x, &b[i].y);
		X2 += b[i].x; Y2 += b[i].y;
	}
	B.x = X2 / (double)n2; B.y = Y2 / (double)n2;
//	printf("%lf %lf\n", W.x, W.y);
//	printf("%lf %lf\n", B.x, B.y);
	v.x = W.x - B.x; v.y = W.y - B.y;
//	printf("%lf %lf\n", v.x, v.y);
	double mx = std::max(fabs(v.x),fabs(v.y));
	if( fabs(mx) > eps )	{v.x /= mx; v.y /= mx;}
//	printf("%lf %lf\n", v.x, v.y);
	
	int pos, neg, zero;
	pos = neg = zero = 0;
	f(i,n1)
	{
		double t = cp( W, B, w[i] );
		if( t > eps )	pos++;
		else
			if( t < eps )	neg ++;
			else			zero ++;
	}
	f(i,n2)
	{
		double t = cp( W, B, b[i] );
		if( t > eps )	pos ++;
		else
			if(t < eps)	neg ++;
			else		zero ++;
	}
	if(neg == pos && zero == 0)
		Print();
	
	pointD WW = W, vv = v;
	for(int i = 0; i < 200; i ++)
	{
		W.y = WW.y;
		for(int j = 0; j < 200; j ++)
		{
			
			int pos, neg, zero;
			pos = neg = zero = 0;
			f(i,n1)
			{
				double t = cp( W, W + v, w[i] );
				if( t > eps )	pos++;
				else
					if( t < eps )	neg ++;
					else			zero ++;
			}
			f(i,n2)
			{
				double t = cp( W, W + v, b[i] );
				if( t > eps )	pos ++;
				else
					if(t < eps)	neg ++;
					else		zero ++;
			}
			if(neg == pos && zero == 0)
				Print();
			W.y += .008;
		}
		W.x += .008;
	}
	
	W = WW;
	
		for(int i = 0; i < 200; i ++)
	{
		W.y = WW.y;
		for(int j = 0; j < 200; j ++)
		{
			
			int pos, neg, zero;
			pos = neg = zero = 0;
			f(i,n1)
			{
				double t = cp( W, W + v, w[i] );
				if( t > eps )	pos++;
				else
					if( t < eps )	neg ++;
					else			zero ++;
			}
			f(i,n2)
			{
				double t = cp( W, W + v, b[i] );
				if( t > eps )	pos ++;
				else
					if(t < eps)	neg ++;
					else		zero ++;
			}
			if(neg == pos && zero == 0)
				Print();
			W.y -= .008;
		}
		W.x -= .008;
	}
	
	W = WW;
	
	
	for(int i = 0; i < 200; i ++)
	{
		v.y = vv.y;
		for(int j = 0; j < 200; j ++)
		{
			
			int pos, neg, zero;
			pos = neg = zero = 0;
			f(k,n1)
			{
				double t = cp( W, W + v, w[k] );
				if( t > eps )	pos++;
				else
					if( t < eps )	neg ++;
					else			zero ++;
			}
			f(k,n2)
			{
				double t = cp( W, W + v, b[k] );
				if( t > eps )	pos ++;
				else
					if(t < eps)	neg ++;
					else		zero ++;
			}
			if(neg == pos && zero == 0)
				Print();
			v.y += .008;
		}
		v.x += .008;
	}
	
	for(int i = 0; i < 200; i ++)
	{
		v.y = vv.y;
		for(int j = 0; j < 200; j ++)
		{
			
			int pos, neg, zero;
			pos = neg = zero = 0;
			f(k,n1)
			{
				double t = cp( W, W + v, w[k] );
				if( t > eps )	pos++;
				else
					if( t < eps )	neg ++;
					else			zero ++;
			}
			f(k,n2)
			{
				double t = cp( W, W + v, b[k] );
				if( t > eps )	pos ++;
				else
					if(t < eps)	neg ++;
					else		zero ++;
			}
			if(neg == pos && zero == 0)
				Print();
			v.y -= .008;
		}
		v.x -= .008;
	}
	

	v = vv;
	
	for(int i = 0; i < 25; i ++)
	{
		W.y = WW.y;
		
		for(int j = 0; j < 25; j ++ )
		{
			v.x = vv.x;
			
			for(int k = 0; k < 25; k ++)
			{
				v.y = vv.y;
				
				for(int l = 0; l < 25; l ++)
				{
					int pos, neg, zero;
					pos = neg = zero = 0;
					f(k,n1)
					{
						double t = cp( W, W + v, w[k] );
						if( t > eps )	pos++;
						else
							if( t < eps )	neg ++;
							else			zero ++;
					}
					f(k,n2)
					{
						double t = cp( W, W + v, b[k] );
						if( t > eps )	pos ++;
						else
							if(t < eps)	neg ++;
							else		zero ++;
					}
					
					if(neg == pos && zero == 0)
						Print();
					
					v.y += .04;
				}
				
				v.x += .04;
			}
			
			W.y += .04;
		}
		
		W.x += .04;
	}
	
	W = WW; v = vv;
	
	for(int i = 0; i < 25; i ++)
	{
		W.y = WW.y;
		
		for(int j = 0; j < 25; j ++ )
		{
			v.x = vv.x;
			
			for(int k = 0; k < 25; k ++)
			{
				v.y = vv.y;
				
				for(int l = 0; l < 25; l ++)
				{
					int pos, neg, zero;
					pos = neg = zero = 0;
					f(k,n1)
					{
						double t = cp( W, W + v, w[k] );
						if( t > eps )	pos++;
						else
							if( t < eps )	neg ++;
							else			zero ++;
					}
					f(k,n2)
					{
						double t = cp( W, W + v, b[k] );
						if( t > eps )	pos ++;
						else
							if(t < eps)	neg ++;
							else		zero ++;
					}
					
					if(neg == pos && zero == 0)
						Print();
					
					v.y -= .04;
				}
				
				v.x -= .04;
			}
			
			W.y -= .04;
		}
		
		W.x -= .04;
	}
	
	printf("0 0 0 0\n");
	
    return 0;
}
