#include <cstdio>

#define fo(i, a, b)							for(int i = a; i <= b; i ++)
#define MAX_N								(10000)

typedef long long LL;

LL MOD;
int N, A, B;
LL dp[MAX_N];

void Read()
{
	scanf("%I64d %d %d %d", &MOD, &N, &A, &B);
}

void Solve()
{
int end;
	
	dp[0] = 1;
	
	fo(i, A, B)
	{
		end = N - i;
		
		fo(j, 0, end)
		{
			dp[i + j] += dp[j];
			
			if(MOD <= dp[i + j]) dp[i + j] -= MOD;
		}
	}
}

void Write()
{
	printf("%I64d\n", dp[N]);
}

int main()
{
	Read();
	
	Solve();
	
	Write();
	
	
	return 0;
}
