#include <iostream>
#include <algorithm>
#include <cmath>
using namespace std;
struct P
	{
		double x,y;
	};

struct L
	{
		P p1,p2;
		double A,B,C;
			void makeline()
				{
					A=p1.y-p2.y;
					B=p2.x-p1.x;
					C=(p1.x*p2.y)-(p1.y*p2.x);
				}
			double orient(P &p1)
				{
					return A*p1.x+B*p1.y+C;
				}
	};	
double dist(P p1,P p2)
	{
		return sqrt((p1.x-p2.x)*(p1.x-p2.x)+(p1.y-p2.y)*(p1.y-p2.y));
	}	
int N,N1;
P p1[102];
P p2[102];
P ob[104];
bool u1[304][301][301];
bool cmp1(P p1,P p2)
	{
		if(p1.y<p2.y) return 1;
			else if(p1.y==p2.y&&p1.x<p2.x) return 1;
			else return 0;
	}
bool cmp2(P p3,P p4)
	{
		if((p3.x-p1[1].x)/dist(p3,p1[1])<(p4.x-p1[1].x)/dist(p4,p1[1])) return 1;
		else return 0;
	}
int brob=2;


void solve()
	{
		int i,j;
		i=1;
			//for(i=1;i<brob;i++)
				{
					P t1,t2;
					t1=ob[i];
					t2=ob[i+1];
				//	cout<<t1.x<<" "<<t1.y<<" "<<t2.x<<" "<<t2.y<<endl;
					double w,u;
					w=t2.x-t1.x;
					u=t2.y-t1.y;
						double k=0.5;
					double ax,ay;
					ax=0.0;
					ay=1.0;
			//	cout<<w<<" "<<u<<endl;
			//		cout<<t1.x+k*w<<" "<<t1.y+k*u<<endl;
						for(ax=-1.0;ax<=1.0;ax+=0.05)
							for(ay=-1.0;ay<=1.0;ay+=0.05)
							{
								int h1,h2;
								//h1=double(ax)*100;
								//h2=double(ay)*100;
								double d1,d2;
								d1=ax*100;
								d2=ay*100;
								h1=int(d1);
								h2=int(d2);
								int k=__gcd(h1,h2);
								h1/=abs(k);
								h2/=abs(k);
								h1+=101;
								h2+=101;
								if(u1[i][h1][h2]) continue;
								u1[i][h1][h2]=1;
							//	cout<<h1<<" "<<h2<<endl;
								double mid;
								
							for(mid=0.01;mid<=1.0;mid+=0.005)
							{
								L l;
							l.p1.x=t1.x+mid*w;
							l.p1.y=t1.y+mid*u;						
							l.p2.x=l.p1.x+ax;
							l.p2.y=l.p1.y+ay;
							l.makeline();
							int wl=0;
							int wr=0;
							int bl=0;
							int br=0;
								for(j=1;j<=N;j++)
									{
										if(l.orient(p1[j])<0.0) wl++;
										else
										if(l.orient(p1[j])>0.0) wr++;
											//else wr++;
									}
								for(j=1;j<=N1;j++)
									{
										if(l.orient(p2[j])<0.0) bl++;
										else
											if(l.orient(p2[j])>0.0) br++;
											//else br++;
									}	
							if(wl==wr&&bl==br&&wl+wr==N&&bl+br==N1)
								{
										//cout<<bl<<" "<<br<<" "<<wl<<" "<<wr<<endl;
									
								//	cout<<l.p2.x<<" "<<l.p2.y<<endl;
							//	cout<<h1<<" "<<h2<<endl;
									printf("%.5lf %.5lf %.5lf %.5lf\n",l.p1.x,l.p1.y,ax,ay);
									//cout<<l.orient(p2[1])<<endl;
								//	for(j=1;j<=N1;j++)
								//		cout<<p2[j].x<<" "<<p2[j].y<<" "<<l.orient(p2[j])<<endl;
									return;
								}	
	
							}	
						}	
										
							
				}	
				printf("0 0 0 0\n");
	}


int main()
{
	scanf("%d",&N);
	int i;
		for(i=1;i<=N;i++)
			scanf("%lf %lf",&p1[i].x,&p1[i].y);
			sort(p1+1,p1+N+1,cmp1);
			sort(p1+2,p1+N+1,cmp2);
		ob[1]=p1[1];	
		ob[2]=p1[2];

			for(i=3;i<=N;i++)
				{
					L l1;
					l1.p1=ob[brob-1];
					l1.p2=p1[i];
					l1.makeline();
					//cout<<brob<<endl;
						if(l1.orient(ob[brob])<0)
							{
								brob--;
								i--;
								continue;
							}
							else
								{
									brob++;
									ob[brob]=p1[i];
								}
				}
			brob++;
			ob[brob]=ob[1];	
	/*	for(i=1;i<=brob;i++)
			cout<<ob[i].x<<" "<<ob[i].y<<endl;
			*/
	scanf("%d",&N1);
		for(i=1;i<=N1;i++)
			scanf("%lf %lf",&p2[i].x,&p2[i].y);
		solve();
		/*double b1,b2;
		b1=6.0;
		b2=4.0;
		/*b1=0.5;
		b2=0.5;
		b1=0.75;
		b2=0.75;
		
		int t1,t2;
		t1=b1*100;
		t2=b2*100;
		int k=__gcd(t1,t2);
		cout<<t1/abs(k)<<" "<<t2/abs(k)<<endl;		*/	
	return 0;
}
