/*
TASK: bw
LANG: C++
*/
// Iordan Boev SMG
# include <stdio.h>
# include <stdlib.h>
# define MAXN (1<<7)

int n,m;
int cntb,cntw;
struct pntb {
	double x,y;	
} white[MAXN];
struct pntc {
	double x,y;	
} black[MAXN];
double px,py,vx,vy;

double os(double x1,double y1,double x2,double y2,double x3,double y3) {
	return x1*y2 + x2*y3+x3*y1-x3*y2-x2*y1-x1*y3;	
}

void read() {
	scanf("%d", &n);
	for(int i = 0; i < n; i++) {
		scanf("%lf %lf", &white[i].x,&white[i].y);	
	}
	scanf("%d", &m);
	for(int i = 0; i < m; i++) {
		scanf("%lf %lf", &black[i].x,&black[i].y);	
	}
}

void print(double x1,double y1,double x2,double y2) {
	printf("%.5lf %.5lf %.5lf %.5lf\n", x1,y1,x2,y2);	
	exit(0);
}

void check(double x1,double y1,double x2,double y2) {
	cntw = 0;
	cntb = 0;
	for(int i = 0; i < n; i++) {
		//printf("os = %lf\n", os(x1,y1,x2,y2,white[i].x,white[i].y));
		if(os(x1,y1,white[i].x,white[i].y,x2,y2) > 0) cntw++;
		if(	os(x1,y1,white[i].x,white[i].y,x2,y2) == 0){
			 cntw = -1;
			 break;
		}
	}
	//printf(">>>>>>  cntw = %d\n ", cntw);
	if(n/2 == cntw) {
		for(int i = 0; i < m; i++) {
			if(os(x1,y1,x2,y2,black[i].x,black[i].y) > 0) cntb++;
			if(os(x1,y1,x2,y2,black[i].x,black[i].y) == 0){
			 cntb = -1;
			 break;			
			}	
		}
		//printf("cntb = %d\n", cntb);
		if(m/2 == cntb) {
			 if(y2 > 0) y2-=py;
			 if(y2 < 0) y2+=py;
			 print(x1,y1,x2,y2);
	
		}
	}	
	
}
	
void solve() {	
	
	//printf("%lf\n", os(0,6,1));
	//check(0.0,6.0,-1.0,0.0);
	for(int i = 0; i < 1000; i++) {
		px = 0.0;
		py = (double)i;	
		vx = 1;
		vy = 0;
		for(int j = 0; j <= 9; j++) {
			vx = 1 - (((double)j)/10.0);
			vy = 0 + (((double)j)/10.0);
			//printf("%lf %lf \n", vx,vy);
			cntw = 0;
			cntb = 0;
			check(px,py,vx+px,vy+py);
			check(px,py,-(vx+px),vy+py);
			check(px,py,vx+px,-(vy+py));
			check(px,py,-(vx+px),-(vy+py));		
		}
		
	}
	printf("0 0 0 0\n");
		
	
}	
	
int main() {
	read();	
	solve();
	return 0;
}
