#include<iostream>
#include<cstdio>
#include<cmath>
using namespace std;
#define mn 256
long long m,n;
double eps= 0.000001;
struct point
{
    double x,y,c;   
}p[mn];
double dist(point p1,point p2)
{
    double a1=p1.x-p2.x;
    double b1=p1.y-p2.y;
    return sqrt((a1*a1)+(b1*b1));
}
double discr(point p1, point p2, point p3)
{
    double a1 = p2.y-p1.y;
    double b1 = -(p2.x-p1.x);
    double c1 = -p1.x*p2.y + p2.x*p1.y;
    return (a1*(p3.x))+(b1*(p3.y))+c1;
}
double sin1(point p1, point p2)
{
    point p3;
    p3.x=p1.x;
    p3.y=p2.y;
    //cout<<atan2(p2.y-p1.y,p2.x-p1.x)<<endl;
    if(atan2(p2.y-p1.y,p2.x-p1.x)>0)
        return dist(p2,p3)/(dist(p1,p2)*1.0);
    else 
        return -dist(p2,p3)/(dist(p1,p2)*1.0);
}
double cos1(point p1, point p2)
{
    point p3;
    p3.x=p1.x;
    p3.y=p2.y;
    if(fabs(atan2(p2.y-p1.y,p2.x-p1.x))>3.1416)
        return -dist(p1,p3)/(dist(p1,p2)*1.0);
    else 
        return dist(p1,p3)/(dist(p1,p2)*1.0);
}
int findans(point p1, point p2)
{
    int b1=0,b2=0,w1=0,w2=0,k,nm=n+m;
            for(k=1;k<=nm;k++)
            {
                if(discr(p1,p2,p[k])>0)
                {
                    if(k<=n)
                        w1++;
                    else
                        b1++;
                }
                else if(discr(p1,p2,p[k])<0)
                {
                    if(k<=n)
                        w2++;
                    else
                        b2++;
                }
                //cout<<discr(p1,p2,p[k])/2<<' ';
            }
    //cout<<endl;
    //printf("%d %d %d %d\n",w1,w2,b1,b2);
    if(w1==w2&&b1==b2)
    return 1;
    return 0;
}
void solve()
{
    int i,j,k,lamp=0;
    double x,y;
    scanf("%d",&n);
    for(i=1;i<=n;i++)
    {
        scanf("%lf%lf",&x,&y);
        p[i].x=x;
        p[i].y=y;
    }
    scanf("%d",&m);
    for(i=n+1;i<=n+m;i++)
    {
        scanf("%lf%lf",&x,&y);
        p[i].x=x;
        p[i].y=y;
    }
    int nm=n+m;
    int w1,w2,b1,b2;
    for(i=1;i<=nm;i++)
    {
        for(j=i+1;j<=nm;j++)
        {
            b1=0;b2=0;w1=0;w2=0;
            for(k=1;k<=nm;k++)
            {
                if(k!=i&&k!=j)
                {
                if(discr(p[i],p[j],p[k])>0)
                {
                    if(k<=n)
                        w1++;
                    else
                        b1++;
                }
                else if(discr(p[i],p[j],p[k])<0)
                {
                    if(k<=n)
                        w2++;
                    else
                        b2++;
                }
                }
                //cout<<discr(p[i],p[j],p[k])<<' ';
            }
            //cout<<i<<' '<<j<<' ';
            //printf("%d %d %d %d\n",w1,w2,b1,b2);
            if(abs(w1-w2)<=1&&abs(b1-b2)<=1)
            {
                //cout<<i<<' '<<j<<' ';
                point p1=p[i];
                point p2=p[j];
                p1.x+=0.00005;
                p2.x-=0.00005;
                if(findans(p1,p2))
                {
                    printf("%0.5lf %lf %lf %lf\n",p1.x,p1.y,sin1(p1,p2),cos1(p1,p2));
                    return;
                }
                p1=p[i];
                p2=p[j];
                p1.x+=0.00005;
                p2.x+=0.00005;
                 if(findans(p1,p2))
                {
                    printf("%0.5lf %0.5lf %0.5lf %0.5lf\n",p1.x,p1.y,sin1(p1,p2),cos1(p1,p2));
                    return;
                }
                p1=p[i];
                p2=p[j];
                p1.x-=0.00005;
                p2.x-=0.00005;
                if(findans(p1,p2))
                {
                    printf("%0.5lf %0.5lf %0.5lf %0.5lf\n",p1.x,p1.y,sin1(p1,p2),cos1(p1,p2));
                    return;
                }
                p1=p[i];
                p2=p[j];
                p1.x-=0.00005;
                p2.x+=0.00005;
                if(findans(p1,p2))
                {
                    printf("%0.5lf %0.5lf %0.5lf %0.5lf\n",p1.x,p1.y,sin1(p1,p2),cos1(p1,p2));
                    return;
                }
            }
        }
    }
    //cout<<discr(p[2],p[4],p[4])<<endl;
    printf("0 0 0 0\n");
}
int main()
{
    solve();
    //system("pause");
    return 0;
}
