#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#define pb push_back
#define S size ()
using namespace std;

const int MAXN = 1 << 14;
vector <int> a[MAXN];
int u[MAXN];
int c[MAXN];
int q[MAXN], br;
int q2[MAXN], br2;
int i, j, n, m;
int comp;
int cur[MAXN], cnt;
int best, ans;

bool dfs (int v) {
    u[v] = 1;
    int k;
    for (k = 0; k < a[v].S; k++) if (q[br-1] != a[v][k] && !c[a[v][k]]) {
        q[++br] = a[v][k];
        if (u[a[v][k]]) {
            //printf ("found\n");
            return 1;
        }
        if (dfs (a[v][k])) return 1;
        br--;
    }
    u[v] = 0;
    return 0;
}

bool dfs2 (int v) {
    u[v] = 1;
    int k;
    for (k = 0; k < a[v].S; k++)
    if (!u[a[v][k]] || (c[a[v][k]] == comp && a[v][k] != cur[j] && q2[br2-1] != a[v][k] && br2 > 1)) {
        q2[++br2] = a[v][k];
        if (c[a[v][k]] == comp && a[v][k] != cur[j] && q2[br2-1] != a[v][k] && br2 > 1) {
            
            //printf (" extend:\n", br2);
            //for (int z = 1; z <= br2; z++) printf ("%d ", q2[z]);
            //printf ("\n--\n");
            return 1;
        }
        if (dfs2 (a[v][k])) return 1;
        br2--;
    }
    if (c[v] != comp) u[v] = 1;
    return 0;
}

void proceed (int v) {
    int v1;
    br = 1;
    q[br] = v;
    // step1
    if (dfs (v)) {
        // step2
        cnt = 0;
        v1 = q[br];
        comp++;
        
        c[q[br]] = comp;
        cur[++cnt] = q[br];
        for (j = br-1; q[j] != q[br]; j--) {
            c[q[j]] = comp;
            cur[++cnt] = q[j];
        }
        //for (j = 1; j <= cnt; j++) printf ("%d ", cur[j]);
        //printf ("\n");
        // step3 - extend
        for (j = 1; j <= cnt; j++) {
            br2 = 0;
            q2[++br2] = cur[j];
            if (dfs2 (cur[j])) {
                int p;
                for (p = br2 - 1; p > 1; p--) {
                    cur[++cnt] = q2[p];
                    c[cur[cnt]] = comp;
                    //printf ("%d ", cur[cnt]);
                    //printf ("\n");
                }
            }
        }
        // calc current
        ans = 0;
        int l;
        for (j = 1; j <= cnt; j++)
            for (l = 0; l < a[cur[j]].S; l++)
                if (c[a[cur[j]][l]] == comp) ans++;
        if (best < ans/2) best = ans/2;
    }
}

void solve () {
    for (i = 1; i <= n; i++)
        if (!c[i]) {
            memset (u, 0, sizeof (u));
            proceed (i);
            //for (j = 1; j <= cnt; j++) printf ("%d ", cur[j]);
            //printf ("\n");
        }
    printf ("%d\n", best);
} 

int main () {
    //freopen ("a3.inp", "rt", stdin);
    //freopen ("a3.out", "wt", stdout);
    scanf ("%d %d", &n, &m);
    int t1, t2;
    for (i = 1; i <= m; i++) {
        scanf ("%d %d", &t1, &t2);
        a[t1].pb (t2);
        a[t2].pb (t1);
    }
    solve ();
    return 0;
}
