#include <cstdio>
#include <vector>
#include <algorithm>
using namespace std;

const int MAXN = 1<<14;

int n , m;
vector < int > a[MAXN];
int cr[MAXN];
int used[MAXN];
int cur;
int cur2;
int can[MAXN];
int begin , start;

void read() {
    scanf ("%d%d",&n,&m);
    int i;
    int x , y;
    
    for (i=1;i<=m;i++) {
        scanf ("%d%d",&x,&y);
        
        a[x].push_back ( y );
        a[y].push_back ( x );
    }
}

void dfsmark ( int node ) {
    used[node] = 1;
    int i;
    
    for (i=0;i<(int)a[node].size();i++)
        if ( !used[ a[node][i] ] )
            dfsmark ( a[node][i] );
}

void dfs2 ( int node ) {
    used[node] = 1;
    int i;
    
    for (i=0;i<(int)a[node].size();i++) {
        if ( cr[ a[node][i] ] ) {
            if ( used[ a[node][i] ] == 1 ) ++ cur2;
            if ( used[ a[node][i] ] )      ++ cur2;
            used[ a[node][i] ] ++;
        } else {
            if ( !used[ a[node][i] ] )
                 dfs2 ( a[node][i] );
            ++ cur;
        } 
    }
}

int solve() {
    if ( !m )
        return 0;
    int ans = 1;
    int cnt = 0;
    int i , j;
    
    for (i=1;i<=n;i++) {
        memset ( used , 0 , sizeof used );
        used[i] = 1;
        if ( (int)a[i].size() ) 
            dfsmark ( a[i][0] );
        
        for (j=1;j<(int)a[i].size();j++) 
            if ( !used[ a[i][j] ] ) {
                cr[i] = 1;
                ++ cnt;
                break;
            }
    }    
    
    for (i=1;i<=n;i++)
        if ( cr[i] ) {
            memset ( used , 0 , sizeof used );
            used[i] = 2;
            
            for (j=0;j<(int)a[i].size();j++)
                if ( cr[ a[i][j] ] ) 
                    ++ used[ a[i][j] ];
                
            for (j=0;j<(int)a[i].size();j++)
                if ( !cr[ a[i][j] ] && !used[ a[i][j] ] ) {
                    cur = cur2 = 0;
                    dfs2 ( a[i][j] );
                    ans = max ( ans , cur/2 + cur2 );
                }
        }
        
    return ans;
}

void dfs ( int node , int last , int prev ) {
    if ( node == start ) return ;
    int begin = used[node];
    used[node] = 2;
    int i;
    
    for (i=0;i<(int)a[node].size();i++) {
        if ( !used[ a[node][i] ] ) {
            dfs ( a[node][i] , can[node]?node:last , node );
        }
        if ( last != a[node][i] && (can[ a[node][i] ] || used[ a[node][i] ] == 1) ) {
            ++ cur;
            if ( used[ a[node][i] ] == 1 ) ++ cur;
            if ( begin == 1 ) ++ cur;
            begin = 2;
            if ( !can[ node ] )
                can[ node ] = 1;
            if ( !can[ a[node][i] ] ) {
                can[ a[node][i] ] = 1;
                used[ a[node][i] ] = 2;
            }
        }
    }
}

int solve2() {
    if ( !m ) return 0;
    int ans = 1;
    int cnt = 0;
    int i , j;
    
    for (i=1;i<=n;i++)
        if ( cr[i] ) {
            memset ( used , 0 , sizeof used );
            memset ( can , 0 , sizeof can );    
            start = i;
            used[i] = 2;
            
            for (j=0;j<(int)a[i].size();j++)
                used[ a[i][j] ] = 1;
                
            for (j=0;j<(int)a[i].size();j++) 
                if ( used[ a[i][j] ] == 1 ) {
                    cur = 0;
                    dfs ( a[i][j] , a[i][j] , a[i][j] );
                    
                    ans = max ( ans , cur );
                }
        }
        
    return min ( m , ans );
}


int main() {
    read();
    printf ("%d\n",max(solve() , solve2()) );
    
    return 0;
}
